<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLCommunicationManager&lt; SUBGRAPH_TYPE &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classTIGLCommunicationManager-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLCommunicationManager&lt; SUBGRAPH_TYPE &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__comm__module.html">Communication</a> &#124; <a class="el" href="group__comm__engine.html">Communication Engine</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Core communicator class definition.  
 <a href="classTIGLCommunicationManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglCommunicationManager_8hpp_source.html">tiglCommunicationManager.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a15791d455909553fd8f3a6626f79b449"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a15791d455909553fd8f3a6626f79b449"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a15791d455909553fd8f3a6626f79b449">TIGLCommunicationManager</a> ()</td></tr>
<tr class="memdesc:a15791d455909553fd8f3a6626f79b449"><td class="mdescLeft">&#160;</td><td class="mdescRight">Empty constructor. <br /></td></tr>
<tr class="separator:a15791d455909553fd8f3a6626f79b449"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a94219b2ca94d4217136373b4cde2b952"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a94219b2ca94d4217136373b4cde2b952">TIGLCommunicationManager</a> (SUBGRAPH_TYPE *<a class="el" href="classTIGLCommunicationManager.html#aad508b38f058c54ba1ac037995be39b3">dataPtr</a>, uint_fast32_t devices, int <a class="el" href="classTIGLCommunicationManager.html#a7f26b4bdfbe6ad5b50ecde994314dafc">rank</a>=0)</td></tr>
<tr class="memdesc:a94219b2ca94d4217136373b4cde2b952"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded constructor constructor.  <a href="#a94219b2ca94d4217136373b4cde2b952">More...</a><br /></td></tr>
<tr class="separator:a94219b2ca94d4217136373b4cde2b952"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78f86a850b851dbc4838b66782a6820a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a78f86a850b851dbc4838b66782a6820a"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a78f86a850b851dbc4838b66782a6820a">~TIGLCommunicationManager</a> ()</td></tr>
<tr class="memdesc:a78f86a850b851dbc4838b66782a6820a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:a78f86a850b851dbc4838b66782a6820a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a30a2c22cbf92ae9c15153bdbc6a5f4ca"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a30a2c22cbf92ae9c15153bdbc6a5f4ca"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a30a2c22cbf92ae9c15153bdbc6a5f4ca">reset</a> ()</td></tr>
<tr class="memdesc:a30a2c22cbf92ae9c15153bdbc6a5f4ca"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset procedure. <br /></td></tr>
<tr class="separator:a30a2c22cbf92ae9c15153bdbc6a5f4ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a305a227aa62d7c63352f0628a6b107f3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a305a227aa62d7c63352f0628a6b107f3">init</a> (SUBGRAPH_TYPE *dPtr, uint_fast32_t devices=1, uint_fast32_t devRank=0)</td></tr>
<tr class="memdesc:a305a227aa62d7c63352f0628a6b107f3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initializes the communicator object.  <a href="#a305a227aa62d7c63352f0628a6b107f3">More...</a><br /></td></tr>
<tr class="separator:a305a227aa62d7c63352f0628a6b107f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adc839af30deaef809baf2738b9b3f11e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#adc839af30deaef809baf2738b9b3f11e">initSS</a> ()</td></tr>
<tr class="memdesc:adc839af30deaef809baf2738b9b3f11e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initializes the flags of the TX/RX tasks at the start of the superstep.  <a href="#adc839af30deaef809baf2738b9b3f11e">More...</a><br /></td></tr>
<tr class="separator:adc839af30deaef809baf2738b9b3f11e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acfcc3974aa363313d7e3c152601ea968"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#acfcc3974aa363313d7e3c152601ea968">isTxComplete</a> ()</td></tr>
<tr class="memdesc:acfcc3974aa363313d7e3c152601ea968"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if all TX messages for the current SS is done.  <a href="#acfcc3974aa363313d7e3c152601ea968">More...</a><br /></td></tr>
<tr class="separator:acfcc3974aa363313d7e3c152601ea968"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1d157081a8950fe730ea3f8e14a08902"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a1d157081a8950fe730ea3f8e14a08902">endSS</a> ()</td></tr>
<tr class="memdesc:a1d157081a8950fe730ea3f8e14a08902"><td class="mdescLeft">&#160;</td><td class="mdescRight">Called at the end of the superstep to flag the end of message generation.  <a href="#a1d157081a8950fe730ea3f8e14a08902">More...</a><br /></td></tr>
<tr class="separator:a1d157081a8950fe730ea3f8e14a08902"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9076e5b7c635703b9207c107cfead352"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a9076e5b7c635703b9207c107cfead352">continuousSendMessages</a> ()</td></tr>
<tr class="memdesc:a9076e5b7c635703b9207c107cfead352"><td class="mdescLeft">&#160;</td><td class="mdescRight">High-level message TX routine.  <a href="#a9076e5b7c635703b9207c107cfead352">More...</a><br /></td></tr>
<tr class="separator:a9076e5b7c635703b9207c107cfead352"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a37761454cc4b64f11802bc6d55a12162"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a37761454cc4b64f11802bc6d55a12162">continuousRecvMessages</a> ()</td></tr>
<tr class="memdesc:a37761454cc4b64f11802bc6d55a12162"><td class="mdescLeft">&#160;</td><td class="mdescRight">Core message receive routine.  <a href="#a37761454cc4b64f11802bc6d55a12162">More...</a><br /></td></tr>
<tr class="separator:a37761454cc4b64f11802bc6d55a12162"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27c5bb4a30d4d070e6c1d3882ee52857"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a27c5bb4a30d4d070e6c1d3882ee52857"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a27c5bb4a30d4d070e6c1d3882ee52857">printIdleTime</a> ()</td></tr>
<tr class="memdesc:a27c5bb4a30d4d070e6c1d3882ee52857"><td class="mdescLeft">&#160;</td><td class="mdescRight">Profiling function that prints the idle time for each task. <br /></td></tr>
<tr class="separator:a27c5bb4a30d4d070e6c1d3882ee52857"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac31139ff09ad51efcf810565331bdc01"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#ac31139ff09ad51efcf810565331bdc01">setTimePtr</a> (uint_fast32_t *timePtr)</td></tr>
<tr class="memdesc:ac31139ff09ad51efcf810565331bdc01"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initializes the communicator object.  <a href="#ac31139ff09ad51efcf810565331bdc01">More...</a><br /></td></tr>
<tr class="separator:ac31139ff09ad51efcf810565331bdc01"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a61e06f7c28704b73a2a75c18be91397b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a61e06f7c28704b73a2a75c18be91397b"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a61e06f7c28704b73a2a75c18be91397b">setNumVertices</a> (uint64_t numVertices)</td></tr>
<tr class="memdesc:a61e06f7c28704b73a2a75c18be91397b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Passes the total number of vertices in the graph (used in finding the device for each vertex) <br /></td></tr>
<tr class="separator:a61e06f7c28704b73a2a75c18be91397b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5538c723dd0a0311954a3d4446b2f9c8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5538c723dd0a0311954a3d4446b2f9c8"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a5538c723dd0a0311954a3d4446b2f9c8">isMultipleDevices</a> ()</td></tr>
<tr class="memdesc:a5538c723dd0a0311954a3d4446b2f9c8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns true if multiple devices are used, otherwise returns false. <br /></td></tr>
<tr class="separator:a5538c723dd0a0311954a3d4446b2f9c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2c85aed301bc21b931a39cec403a43f0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a2c85aed301bc21b931a39cec403a43f0">sendSysMessages</a> ()</td></tr>
<tr class="memdesc:a2c85aed301bc21b931a39cec403a43f0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sends all system messages. This is a blocking function.  <a href="#a2c85aed301bc21b931a39cec403a43f0">More...</a><br /></td></tr>
<tr class="separator:a2c85aed301bc21b931a39cec403a43f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a846cfc94d9aa1cc520e8fcdb3157c1c7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a846cfc94d9aa1cc520e8fcdb3157c1c7">sendMutationMessages</a> ()</td></tr>
<tr class="memdesc:a846cfc94d9aa1cc520e8fcdb3157c1c7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sends all mutation messages. This is a blocking function.  <a href="#a846cfc94d9aa1cc520e8fcdb3157c1c7">More...</a><br /></td></tr>
<tr class="separator:a846cfc94d9aa1cc520e8fcdb3157c1c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a181cd2156fe5e5e407842f2390f3e110"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a181cd2156fe5e5e407842f2390f3e110"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a181cd2156fe5e5e407842f2390f3e110">sendInstMutationMessage</a> (int thread)</td></tr>
<tr class="memdesc:a181cd2156fe5e5e407842f2390f3e110"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sends a single mutation messages. This is a blocking function. <br /></td></tr>
<tr class="separator:a181cd2156fe5e5e407842f2390f3e110"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ea1040f1fa41c905e72e96800e13c3f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a5ea1040f1fa41c905e72e96800e13c3f">taggedBcast</a> (uint8_t *txBuf, uint_fast32_t bufSize, int tag)</td></tr>
<tr class="memdesc:a5ea1040f1fa41c905e72e96800e13c3f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded function for sending a single message to a particular destination with a given tag.  <a href="#a5ea1040f1fa41c905e72e96800e13c3f">More...</a><br /></td></tr>
<tr class="separator:a5ea1040f1fa41c905e72e96800e13c3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af049638494f8ff5b1672c2e1df199b6c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#af049638494f8ff5b1672c2e1df199b6c">instRecvMutationMessages</a> (int dev)</td></tr>
<tr class="memdesc:af049638494f8ff5b1672c2e1df199b6c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Core function for receiving all mutation messages from a given device.  <a href="#af049638494f8ff5b1672c2e1df199b6c">More...</a><br /></td></tr>
<tr class="separator:af049638494f8ff5b1672c2e1df199b6c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acf31426be68777913b2c5a96af8e77f1"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acf31426be68777913b2c5a96af8e77f1"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#acf31426be68777913b2c5a96af8e77f1">getRank</a> ()</td></tr>
<tr class="memdesc:acf31426be68777913b2c5a96af8e77f1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the rank of the device. <br /></td></tr>
<tr class="separator:acf31426be68777913b2c5a96af8e77f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:ab649052e08a2c344c3d85eb7ec9dc83e"><td class="memTemplParams" colspan="2">template&lt;typename MESSAGE_TYPE &gt; </td></tr>
<tr class="memitem:ab649052e08a2c344c3d85eb7ec9dc83e"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#ab649052e08a2c344c3d85eb7ec9dc83e">bytes2Messages</a> (uint8_t *rxBuf, uint_fast32_t messageSize, vector&lt; MESSAGE_TYPE &gt; &amp;messageBuf)</td></tr>
<tr class="memdesc:ab649052e08a2c344c3d85eb7ec9dc83e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a sequence of bytes to messages (can be one or more than one messages)  <a href="#ab649052e08a2c344c3d85eb7ec9dc83e">More...</a><br /></td></tr>
<tr class="separator:ab649052e08a2c344c3d85eb7ec9dc83e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbe3506a4b314c7f03d1ea6c2f610fbf"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#acbe3506a4b314c7f03d1ea6c2f610fbf">messages2Bytes</a> (DATA_MESSAGE_BUF_TYPE *messagePtr, uint8_t *outBuf)</td></tr>
<tr class="memdesc:acbe3506a4b314c7f03d1ea6c2f610fbf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a group of data messages to a sequence of bytes to be sent.  <a href="#acbe3506a4b314c7f03d1ea6c2f610fbf">More...</a><br /></td></tr>
<tr class="separator:acbe3506a4b314c7f03d1ea6c2f610fbf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5276cfab81cf55da2d35c8af582e03ac"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a5276cfab81cf55da2d35c8af582e03ac">processOneMessage</a> (uint8_t *rxBuf, int tag, uint_fast32_t messageSize, uint_fast32_t dev)</td></tr>
<tr class="memdesc:a5276cfab81cf55da2d35c8af582e03ac"><td class="mdescLeft">&#160;</td><td class="mdescRight">Processes a single received message.  <a href="#a5276cfab81cf55da2d35c8af582e03ac">More...</a><br /></td></tr>
<tr class="separator:a5276cfab81cf55da2d35c8af582e03ac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7039a28d4b3a941939eb4d8f49a8c646"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a7039a28d4b3a941939eb4d8f49a8c646">countMessages</a> (uint_fast32_t *devMessagesCount)</td></tr>
<tr class="memdesc:a7039a28d4b3a941939eb4d8f49a8c646"><td class="mdescLeft">&#160;</td><td class="mdescRight">Counts the number of messages to each device.  <a href="#a7039a28d4b3a941939eb4d8f49a8c646">More...</a><br /></td></tr>
<tr class="separator:a7039a28d4b3a941939eb4d8f49a8c646"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac1e58a16c647584182e54f5a7298c7c6"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#ac1e58a16c647584182e54f5a7298c7c6">existDataMessages2Tx</a> ()</td></tr>
<tr class="separator:ac1e58a16c647584182e54f5a7298c7c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a87c0248a274ed0bac2c1468af1246e8b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a87c0248a274ed0bac2c1468af1246e8b">existSysMessages2Tx</a> ()</td></tr>
<tr class="memdesc:a87c0248a274ed0bac2c1468af1246e8b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if there is any new system message to transmit to other devices.  <a href="#a87c0248a274ed0bac2c1468af1246e8b">More...</a><br /></td></tr>
<tr class="separator:a87c0248a274ed0bac2c1468af1246e8b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a45a9101c41e6acfadeab414d89c807bc"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a45a9101c41e6acfadeab414d89c807bc">existMutationMessages2Tx</a> ()</td></tr>
<tr class="memdesc:a45a9101c41e6acfadeab414d89c807bc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if there is any new mutation message to transmit to other devices.  <a href="#a45a9101c41e6acfadeab414d89c807bc">More...</a><br /></td></tr>
<tr class="separator:a45a9101c41e6acfadeab414d89c807bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a268fd4355c2e26042cde95789f2742e4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a268fd4355c2e26042cde95789f2742e4">sendDataMessages</a> (bool flushBuffers=false)</td></tr>
<tr class="memdesc:a268fd4355c2e26042cde95789f2742e4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if there is any new system message to transmit to other devices.  <a href="#a268fd4355c2e26042cde95789f2742e4">More...</a><br /></td></tr>
<tr class="separator:a268fd4355c2e26042cde95789f2742e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba5cdc84bd295db4b422cf83e03091b7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aba5cdc84bd295db4b422cf83e03091b7"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#aba5cdc84bd295db4b422cf83e03091b7">sendMessagesSizes</a> ()</td></tr>
<tr class="memdesc:aba5cdc84bd295db4b422cf83e03091b7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sends the count of data messages to all devices. <br /></td></tr>
<tr class="separator:aba5cdc84bd295db4b422cf83e03091b7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af793ef35e5577541fce11b0ad6f348db"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#af793ef35e5577541fce11b0ad6f348db">waitAllTx</a> ()</td></tr>
<tr class="memdesc:af793ef35e5577541fce11b0ad6f348db"><td class="mdescLeft">&#160;</td><td class="mdescRight">Waits for all pending TX messages.  <a href="#af793ef35e5577541fce11b0ad6f348db">More...</a><br /></td></tr>
<tr class="separator:af793ef35e5577541fce11b0ad6f348db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af235522e49a7b5b9fc5191bd753b317e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#af235522e49a7b5b9fc5191bd753b317e">findTxSlot</a> ()</td></tr>
<tr class="memdesc:af235522e49a7b5b9fc5191bd753b317e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the index of an available TX slot to be used for nonblocking transmission.  <a href="#af235522e49a7b5b9fc5191bd753b317e">More...</a><br /></td></tr>
<tr class="separator:af235522e49a7b5b9fc5191bd753b317e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5e85a0e37d05127470d05c8d2918fb3"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#af5e85a0e37d05127470d05c8d2918fb3">RecvNewMessages</a> ()</td></tr>
<tr class="memdesc:af5e85a0e37d05127470d05c8d2918fb3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Core function for the receive communication task; it wait and receives all new messages.  <a href="#af5e85a0e37d05127470d05c8d2918fb3">More...</a><br /></td></tr>
<tr class="separator:af5e85a0e37d05127470d05c8d2918fb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:aad508b38f058c54ba1ac037995be39b3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aad508b38f058c54ba1ac037995be39b3"></a>
SUBGRAPH_TYPE *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#aad508b38f058c54ba1ac037995be39b3">dataPtr</a></td></tr>
<tr class="memdesc:aad508b38f058c54ba1ac037995be39b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to PregelDataContainer object that contains all message buffers <br /></td></tr>
<tr class="separator:aad508b38f058c54ba1ac037995be39b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6fa8fbb6818efd2c72360f354fcd8c6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af6fa8fbb6818efd2c72360f354fcd8c6"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#af6fa8fbb6818efd2c72360f354fcd8c6">initFlag</a></td></tr>
<tr class="memdesc:af6fa8fbb6818efd2c72360f354fcd8c6"><td class="mdescLeft">&#160;</td><td class="mdescRight">initlialization flag <br /></td></tr>
<tr class="separator:af6fa8fbb6818efd2c72360f354fcd8c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ae7ac30bbb2d7938b2bed7b4a4f21db"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4ae7ac30bbb2d7938b2bed7b4a4f21db"></a>
int_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a4ae7ac30bbb2d7938b2bed7b4a4f21db">numDevices</a></td></tr>
<tr class="memdesc:a4ae7ac30bbb2d7938b2bed7b4a4f21db"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of devices <br /></td></tr>
<tr class="separator:a4ae7ac30bbb2d7938b2bed7b4a4f21db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4af56522c0cbc793788b38985e086c8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad4af56522c0cbc793788b38985e086c8"></a>
uint64_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#ad4af56522c0cbc793788b38985e086c8">totalNumVertices</a></td></tr>
<tr class="memdesc:ad4af56522c0cbc793788b38985e086c8"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of vertices in all devices <br /></td></tr>
<tr class="separator:ad4af56522c0cbc793788b38985e086c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac7a34f82443f2d7f9d360733e3612e71"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac7a34f82443f2d7f9d360733e3612e71"></a>
uint_fast32_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#ac7a34f82443f2d7f9d360733e3612e71">timeCountSS</a></td></tr>
<tr class="memdesc:ac7a34f82443f2d7f9d360733e3612e71"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to the ss counter <br /></td></tr>
<tr class="separator:ac7a34f82443f2d7f9d360733e3612e71"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f26b4bdfbe6ad5b50ecde994314dafc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7f26b4bdfbe6ad5b50ecde994314dafc"></a>
int_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a7f26b4bdfbe6ad5b50ecde994314dafc">rank</a></td></tr>
<tr class="memdesc:a7f26b4bdfbe6ad5b50ecde994314dafc"><td class="mdescLeft">&#160;</td><td class="mdescRight">MPI rank of the current device. <br /></td></tr>
<tr class="separator:a7f26b4bdfbe6ad5b50ecde994314dafc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa984b9688cd64536c6901729a536b07e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa984b9688cd64536c6901729a536b07e"></a>
MPI_Request&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#aa984b9688cd64536c6901729a536b07e">txRequests</a> [NONBLOCKING_TX_THREADS]</td></tr>
<tr class="memdesc:aa984b9688cd64536c6901729a536b07e"><td class="mdescLeft">&#160;</td><td class="mdescRight">MPI_Request objectsfor nonBlocking TX. <br /></td></tr>
<tr class="separator:aa984b9688cd64536c6901729a536b07e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7102a95cb3b26dfb0c3704184183cb6b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7102a95cb3b26dfb0c3704184183cb6b"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a7102a95cb3b26dfb0c3704184183cb6b">txBusyRequestFlag</a> [NONBLOCKING_TX_THREADS]</td></tr>
<tr class="memdesc:a7102a95cb3b26dfb0c3704184183cb6b"><td class="mdescLeft">&#160;</td><td class="mdescRight">flags nonBlocking TX <br /></td></tr>
<tr class="separator:a7102a95cb3b26dfb0c3704184183cb6b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac73c7a6147bb9bf5922d1f19f3ca524e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac73c7a6147bb9bf5922d1f19f3ca524e"></a>
uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#ac73c7a6147bb9bf5922d1f19f3ca524e">txBuffers</a> [NONBLOCKING_TX_THREADS][MAX_MESSAGE_SIZE]</td></tr>
<tr class="memdesc:ac73c7a6147bb9bf5922d1f19f3ca524e"><td class="mdescLeft">&#160;</td><td class="mdescRight">output buffers for the different TX threads <br /></td></tr>
<tr class="separator:ac73c7a6147bb9bf5922d1f19f3ca524e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a906895636bcf6765c145fee98f783a6a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a906895636bcf6765c145fee98f783a6a"></a>
uint_fast32_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a906895636bcf6765c145fee98f783a6a">dataTxCount</a></td></tr>
<tr class="memdesc:a906895636bcf6765c145fee98f783a6a"><td class="mdescLeft">&#160;</td><td class="mdescRight">counter for data messages <br /></td></tr>
<tr class="separator:a906895636bcf6765c145fee98f783a6a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3793829e7ef861f7b5b17860067ee48b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3793829e7ef861f7b5b17860067ee48b"></a>
uint_fast32_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a3793829e7ef861f7b5b17860067ee48b">mutationTxCount</a></td></tr>
<tr class="memdesc:a3793829e7ef861f7b5b17860067ee48b"><td class="mdescLeft">&#160;</td><td class="mdescRight">counter for mutation messages <br /></td></tr>
<tr class="separator:a3793829e7ef861f7b5b17860067ee48b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75211a6169aaac4eed3d58bf01c82c76"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a75211a6169aaac4eed3d58bf01c82c76"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a75211a6169aaac4eed3d58bf01c82c76">sysTxCount</a></td></tr>
<tr class="memdesc:a75211a6169aaac4eed3d58bf01c82c76"><td class="mdescLeft">&#160;</td><td class="mdescRight">counter for system messages <br /></td></tr>
<tr class="separator:a75211a6169aaac4eed3d58bf01c82c76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a96784692fde5caddb9e66d0a09e558ce"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a96784692fde5caddb9e66d0a09e558ce"></a>
<a class="el" href="structTIGLCommunicationMessageDev.html">TIGLCommunicationMessageDev</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a96784692fde5caddb9e66d0a09e558ce">devTxMessages</a></td></tr>
<tr class="memdesc:a96784692fde5caddb9e66d0a09e558ce"><td class="mdescLeft">&#160;</td><td class="mdescRight">message counter for the device messages <br /></td></tr>
<tr class="separator:a96784692fde5caddb9e66d0a09e558ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa8ffcfa91ccbfdfd960bb4d49b0a58d8"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa8ffcfa91ccbfdfd960bb4d49b0a58d8"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#aa8ffcfa91ccbfdfd960bb4d49b0a58d8">ssComputationEndFlag</a></td></tr>
<tr class="memdesc:aa8ffcfa91ccbfdfd960bb4d49b0a58d8"><td class="mdescLeft">&#160;</td><td class="mdescRight">flag of the end of the SS execution (no more messages are generated) <br /></td></tr>
<tr class="separator:aa8ffcfa91ccbfdfd960bb4d49b0a58d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa1078d0a68d9c673ac78b269a05afb5f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa1078d0a68d9c673ac78b269a05afb5f"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#aa1078d0a68d9c673ac78b269a05afb5f">ssTxActiveFlag</a></td></tr>
<tr class="memdesc:aa1078d0a68d9c673ac78b269a05afb5f"><td class="mdescLeft">&#160;</td><td class="mdescRight">flag of the end TX for current SS <br /></td></tr>
<tr class="separator:aa1078d0a68d9c673ac78b269a05afb5f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b958601eb31e864eadcc7894b1499dd"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9b958601eb31e864eadcc7894b1499dd"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a9b958601eb31e864eadcc7894b1499dd">ssRxActiveFlag</a></td></tr>
<tr class="memdesc:a9b958601eb31e864eadcc7894b1499dd"><td class="mdescLeft">&#160;</td><td class="mdescRight">flag of the end RX for current SS <br /></td></tr>
<tr class="separator:a9b958601eb31e864eadcc7894b1499dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2409da069a49ea13d88a1c9901b28006"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2409da069a49ea13d88a1c9901b28006"></a>
int_fast32_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a2409da069a49ea13d88a1c9901b28006">rxDevMessageCount</a></td></tr>
<tr class="memdesc:a2409da069a49ea13d88a1c9901b28006"><td class="mdescLeft">&#160;</td><td class="mdescRight">holds the number of received messages from each device (incremented with each new message) <br /></td></tr>
<tr class="separator:a2409da069a49ea13d88a1c9901b28006"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a863e67876467738e18090713f98a43b3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a863e67876467738e18090713f98a43b3"></a>
int_fast32_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a863e67876467738e18090713f98a43b3">targetRxDevMessageCount</a></td></tr>
<tr class="memdesc:a863e67876467738e18090713f98a43b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">holds the target number of messages from each device <br /></td></tr>
<tr class="separator:a863e67876467738e18090713f98a43b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4e09ccded269eb73471b10d609d64c4a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4e09ccded269eb73471b10d609d64c4a"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLCommunicationManager.html#a4e09ccded269eb73471b10d609d64c4a">txIdleTime</a></td></tr>
<tr class="memdesc:a4e09ccded269eb73471b10d609d64c4a"><td class="mdescLeft">&#160;</td><td class="mdescRight">profiling information for the processing tasks <br /></td></tr>
<tr class="separator:a4e09ccded269eb73471b10d609d64c4a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename SUBGRAPH_TYPE&gt;<br />
class TIGLCommunicationManager&lt; SUBGRAPH_TYPE &gt;</h3>

<p>Core communicator class definition. </p>
<p>It handles all the MPI communication between devices (including both system and data messages) It is a template class that is parameterized by </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">SUBGRAPH_TYPE</td><td>the class definition of the data manager object </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a94219b2ca94d4217136373b4cde2b952"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::<a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a> </td>
          <td>(</td>
          <td class="paramtype">SUBGRAPH_TYPE *&#160;</td>
          <td class="paramname"><em>dataPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>devices</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>rank</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded constructor constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dataPtr</td><td>pointer to the data manager object </td></tr>
    <tr><td class="paramname">devices</td><td>total number of devices </td></tr>
    <tr><td class="paramname">rank</td><td>rank of current device </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="ab649052e08a2c344c3d85eb7ec9dc83e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<div class="memtemplate">
template&lt;typename MESSAGE_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::bytes2Messages </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>messageSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&lt; MESSAGE_TYPE &gt; &amp;&#160;</td>
          <td class="paramname"><em>messageBuf</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Convert a sequence of bytes to messages (can be one or more than one messages) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>pointer to bytes to be converted </td></tr>
    <tr><td class="paramname">messageSize</td><td>number of bytes to convert </td></tr>
    <tr><td class="paramname">messageBuf</td><td>message buffer to stored converted messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a37761454cc4b64f11802bc6d55a12162"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::continuousRecvMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Core message receive routine. </p>
<p><b>Procedure</b> </p><ol type="1">
<li>Wait until RX is enabled.</li>
<li>Receive all new messages by calling <a class="el" href="classTIGLCommunicationManager.html#af5e85a0e37d05127470d05c8d2918fb3">RecvNewMessages </a>.</li>
<li>Deactivate RX flag </li>
</ol>

</div>
</div>
<a class="anchor" id="a9076e5b7c635703b9207c107cfead352"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::continuousSendMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>High-level message TX routine. </p>
<p><b>Procedure</b> </p><ol type="1">
<li>Wait until TX is enabled.</li>
<li>Continue check and send available messages as long as the superstep computation flag is active.</li>
<li>If the superstep flag becomes inactive, check and send any residual messages.</li>
<li>Send a count of the total number of message to all devices.</li>
<li>Deactivate TX flag. </li>
</ol>

</div>
</div>
<a class="anchor" id="a7039a28d4b3a941939eb4d8f49a8c646"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::countMessages </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t *&#160;</td>
          <td class="paramname"><em>devMessagesCount</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Counts the number of messages to each device. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">devMessagesCount</td><td>pointer to the output buffer that contains the count for each device </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1d157081a8950fe730ea3f8e14a08902"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::endSS </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Called at the end of the superstep to flag the end of message generation. </p>
<p>it waits for all TX/RX to complete before going to the superstep barrier </p>

</div>
</div>
<a class="anchor" id="ac1e58a16c647584182e54f5a7298c7c6"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::existDataMessages2Tx </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>check if there is any new data message to transmit to other devices </p><dl class="section return"><dt>Returns</dt><dd>true if there exists messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a45a9101c41e6acfadeab414d89c807bc"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::existMutationMessages2Tx </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Checks if there is any new mutation message to transmit to other devices. </p>
<dl class="section return"><dt>Returns</dt><dd>true if there exists mutation messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a87c0248a274ed0bac2c1468af1246e8b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::existSysMessages2Tx </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Checks if there is any new system message to transmit to other devices. </p>
<dl class="section return"><dt>Returns</dt><dd>true if there exists system messages, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="af235522e49a7b5b9fc5191bd753b317e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::findTxSlot </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the index of an available TX slot to be used for nonblocking transmission. </p>
<p><b>Procedure</b> </p><ol type="1">
<li>search for any slot that has not been used before, and if any return its index</li>
<li>If all slots have been used before, find any TX slots that finished it nonblocking transmission. </li>
</ol>

</div>
</div>
<a class="anchor" id="a305a227aa62d7c63352f0628a6b107f3"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::init </td>
          <td>(</td>
          <td class="paramtype">SUBGRAPH_TYPE *&#160;</td>
          <td class="paramname"><em>dPtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>devices</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>devRank</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Initializes the communicator object. </p>
<p>It performs all necsssary memory allocations </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dPtr</td><td>pointer to the data container object </td></tr>
    <tr><td class="paramname">devices</td><td>total number of devices </td></tr>
    <tr><td class="paramname">devRank</td><td>rank of the current device </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="adc839af30deaef809baf2738b9b3f11e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::initSS </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Initializes the flags of the TX/RX tasks at the start of the superstep. </p>
<p>This method must be called at the beginning of each superstep </p>

</div>
</div>
<a class="anchor" id="af049638494f8ff5b1672c2e1df199b6c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::instRecvMutationMessages </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>dev</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Core function for receiving all mutation messages from a given device. </p>
<p>It checks for input MPI messages and routes each mutation message to the local mutation message buffer </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dev</td><td>the source device </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if there exists messages, false otherwise </dd></dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Repeat until no more message exists</li>
</ol>
<ol type="1">
<li>If a message exists, check its size</li>
<li>If the size is bigger than the local buffer, allocate an overflow buffer and read the message to that buffer.</li>
<li>Else read the message to to the local buffer</li>
<li>unpack the messages, and push to the mutation message buffer </li>
</ol>

</div>
</div>
<a class="anchor" id="acfcc3974aa363313d7e3c152601ea968"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::isTxComplete </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks if all TX messages for the current SS is done. </p>
<dl class="section return"><dt>Returns</dt><dd>true if TX completed, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="acbe3506a4b314c7f03d1ea6c2f610fbf"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::messages2Bytes </td>
          <td>(</td>
          <td class="paramtype">DATA_MESSAGE_BUF_TYPE *&#160;</td>
          <td class="paramname"><em>messagePtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>outBuf</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Convert a group of data messages to a sequence of bytes to be sent. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">messagePtr</td><td>pointer to message buffer </td></tr>
    <tr><td class="paramname">outBuf</td><td>pointer to allocated uint8_t buffer </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>number of bytes consumed </dd></dl>

</div>
</div>
<a class="anchor" id="a5276cfab81cf55da2d35c8af582e03ac"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::processOneMessage </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>rxBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>messageSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>dev</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Processes a single received message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">rxBuf</td><td>message buffer </td></tr>
    <tr><td class="paramname">tag</td><td>message tag </td></tr>
    <tr><td class="paramname">messageSize</td><td>messages size in bytes </td></tr>
    <tr><td class="paramname">dev</td><td>source device </td></tr>
  </table>
  </dd>
</dl>
<p><b>Procedure</b> </p>
<ol type="1">
<li>if system message, read and push it to system message buffer.</li>
<li>if data message, read and route to appropriate vertex message buffer. If the destination vertex does not exist send a system error message.</li>
<li>If mutation message, read and route to mutation message buffer.</li>
<li>If a count message, set the target number of message from the source device. </li>
</ol>

</div>
</div>
<a class="anchor" id="af5e85a0e37d05127470d05c8d2918fb3"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::RecvNewMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Core function for the receive communication task; it wait and receives all new messages. </p>
<p><b>Procedure</b> </p><ol type="1">
<li>Initialize all RX slots as available.</li>
<li>While there are messages to receive, do the following steps.</li>
<li>Find all available RX slots, and start a nonblocking receive if a message is available to read.</li>
<li>Find all RX slots that finished receiving, and process the corresponding message using <a class="el" href="classTIGLCommunicationManager.html#a5276cfab81cf55da2d35c8af582e03ac">processOneMessage </a>.</li>
<li>Mark all finished RX slots as available.</li>
<li>If there is no new messages, and the target number of messages is not reached exit with error; otherwise return normally. </li>
</ol>

</div>
</div>
<a class="anchor" id="a268fd4355c2e26042cde95789f2742e4"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::sendDataMessages </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>flushBuffers</em> = <code>false</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Checks if there is any new system message to transmit to other devices. </p>
<dl class="section return"><dt>Returns</dt><dd>true if there exists system messages, false otherwise </dd></dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Iterate over all data messages</li>
<li>Find the destination device</li>
</ol>
<ol type="1">
<li>Convert the message to bytes and copy it to the local buffer of the target device.</li>
<li>If the buffer is full, find a transmission slot and send the message using nonblocking TX.</li>
<li>update the communication statistics after message transmission </li>
</ol>

</div>
</div>
<a class="anchor" id="a846cfc94d9aa1cc520e8fcdb3157c1c7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::sendMutationMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sends all mutation messages. This is a blocking function. </p>
<p><b>Procedure</b> </p>
<ol type="1">
<li>Iterate over all devices</li>
<li>iterate over all messages, and extract mutation messages going to the current device to a local buffer.</li>
<li>If the buffer is full, send its messages to the target device, and clear for refill </li>
</ol>

</div>
</div>
<a class="anchor" id="a2c85aed301bc21b931a39cec403a43f0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::sendSysMessages </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sends all system messages. This is a blocking function. </p>
<p><b>Procedure</b> </p>
<ol type="1">
<li>copying all system messages to a local buffer.</li>
<li>Itarate over all message, if it has code AGGREGATE_INFO, DEV_IDLE, or HALT, broadcast to all devices. Otherwise, send only to target device. </li>
</ol>

</div>
</div>
<a class="anchor" id="ac31139ff09ad51efcf810565331bdc01"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::setTimePtr </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t *&#160;</td>
          <td class="paramname"><em>timePtr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Initializes the communicator object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">timePtr</td><td>pointer to the time count </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5ea1040f1fa41c905e72e96800e13c3f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::taggedBcast </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>txBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>bufSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tag</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded function for sending a single message to a particular destination with a given tag. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">txBuf</td><td>tx buffer </td></tr>
    <tr><td class="paramname">bufSize</td><td>buffer size </td></tr>
    <tr><td class="paramname">tag</td><td>message tag </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af793ef35e5577541fce11b0ad6f348db"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a>&lt; SUBGRAPH_TYPE &gt;::waitAllTx </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Waits for all pending TX messages. </p>
<p><b>Procedure</b> </p><ol type="1">
<li>Wait for all data/system/mutation messages</li>
<li>Wait for count messages to all devices </li>
</ol>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="tiglCommunicationManager_8hpp_source.html">tiglCommunicationManager.hpp</a></li>
<li><a class="el" href="tiglCommunicationManagerImplementation_8hpp_source.html">tiglCommunicationManagerImplementation.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:56 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
